#Random Forest
import numpy as np
import pandas as pd
from sklearn import metrics

import warnings
warnings.filterwarnings('ignore')

import os
os.environ["CUDA_VISIBLE_DEVICES"]="0"

file_path_full_training_set = '../Restructure_data/train_data+_ADASYN_5.csv'
file_path_test = '../Restructure_data/test_data+_5.csv'
file_path_test1 = '../Restructure_data/test_data+_11.csv'
file_path_test2='../Restructure_data/test_data+_12.csv'

df = pd.read_csv(file_path_full_training_set)
test_df = pd.read_csv(file_path_test)
test_df1=pd.read_csv(file_path_test1)#binary classification
test_df2=pd.read_csv(file_path_test2)#multi classification

# binary labels
df['attack_class']=df['attack_class'].replace([0],[0])
df['attack_class']=df['attack_class'].replace([1],[1])
df['attack_class']=df['attack_class'].replace([2],[1])
df['attack_class']=df['attack_class'].replace([3],[1])
df['attack_class']=df['attack_class'].replace([4],[1])
#
test_df['attack_class']=test_df['attack_class'].replace([0],[0])
test_df['attack_class']=test_df['attack_class'].replace([1],[1])
test_df['attack_class']=test_df['attack_class'].replace([2],[1])
test_df['attack_class']=test_df['attack_class'].replace([3],[1])
test_df['attack_class']=test_df['attack_class'].replace([4],[1])

data = df.copy()
test_data = test_df.copy()

X_train = data.drop('attack_class' , axis = 1)
X_test = test_data.drop('attack_class' , axis = 1)
y_train = data['attack_class']
y_test = test_data['attack_class']
print(X_train.shape)

from sklearn.ensemble import RandomForestClassifier

rnd_clf = RandomForestClassifier(n_estimators=300, random_state=42)
rnd_clf.fit(X_train, y_train)
y_pred_rf = rnd_clf.predict(X_test)
score=rnd_clf.score(X_test, y_test)
cm=metrics.confusion_matrix(y_test,y_pred_rf)
print("Confusion Matrix")
print(cm)
print(score)

class_0=[]#Store sample indexes predicted to be positive
class_1=[]#Store sample indexes predicted to be negative
new_test_bi=[]#Store samples predicted to be positive
new_test1_bi=[]#Store samples predicted to be negative
new_test_mul=[]
new_test1_mul=[]
for i in range(len(y_pred_rf)):
    if (y_pred_rf[i]==0):
        class_0.append(i)
        new_test_bi.append(test_df1.loc[i])
        new_test_mul.append(test_df2.loc[i])
    else:
        class_1.append(i)
        new_test1_bi.append(test_df1.loc[i])
        new_test1_mul.append(test_df2.loc[i])

new_test1_bi=pd.DataFrame(new_test1_bi)
new_test1_bi.to_csv('../New_Data/new_test+_attack-bi.csv',index=False)
new_test_bi=pd.DataFrame(new_test_bi)
new_test_bi.to_csv('../New_Data/new_test+_normal-bi.csv',index=False)
new_test1_mul=pd.DataFrame(new_test1_mul)
new_test1_mul.to_csv('../New_Data/new_test+_attack-mul.csv',index=False)
new_test_mul=pd.DataFrame(new_test_mul)
new_test_mul.to_csv('../New_Data/new_test+_normal-mul.csv',index=False)

