import math
import numpy as np
import pandas as pd
from keras.models import Sequential, load_model
from keras.distribute.keras_utils_test import Counter
from sklearn.metrics import confusion_matrix
from sklearn import metrics
from sklearn.metrics import precision_score
from sklearn.metrics import recall_score
from sklearn.metrics import f1_score
from sklearn.metrics import classification_report
from sklearn.metrics import accuracy_score
from sklearn.model_selection import StratifiedKFold
import numpy
import tensorflow.keras
from tensorflow.keras.layers import LSTM, SimpleRNN, GRU, Bidirectional, BatchNormalization,Convolution1D,MaxPooling1D, Reshape, GlobalAveragePooling1D
from tensorflow.keras.utils import to_categorical
from tensorflow.keras.layers import Dense,Input, Dropout, Embedding, Flatten,MaxPooling1D,Conv1D,SimpleRNN,LSTM,GRU,Multiply,GlobalMaxPooling1D
from tensorflow.keras.layers import Bidirectional,Activation,BatchNormalization,GlobalAveragePooling1D,MultiHeadAttention
from tensorflow.keras.models import Sequential,Model
import tensorflow as tf

import warnings
warnings.filterwarnings('ignore')

import os
os.environ["CUDA_VISIBLE_DEVICES"]="0"

#Random Forest
file_path_full_training_set = './Restructure_data/train_data+_ADASYN_5.csv'
file_path_test = './Restructure_data/test_data+_5.csv'

df = pd.read_csv(file_path_full_training_set)
test_df = pd.read_csv(file_path_test)

# binary labels
df['attack_class']=df['attack_class'].replace([0],[0])
df['attack_class']=df['attack_class'].replace([1],[1])
df['attack_class']=df['attack_class'].replace([2],[1])
df['attack_class']=df['attack_class'].replace([3],[1])
df['attack_class']=df['attack_class'].replace([4],[1])
#
test_df['attack_class']=test_df['attack_class'].replace([0],[0])
test_df['attack_class']=test_df['attack_class'].replace([1],[1])
test_df['attack_class']=test_df['attack_class'].replace([2],[1])
test_df['attack_class']=test_df['attack_class'].replace([3],[1])
test_df['attack_class']=test_df['attack_class'].replace([4],[1])

data = df.copy()
test_data = test_df.copy()

X_train = data.drop('attack_class' , axis = 1)
X_test = test_data.drop('attack_class' , axis = 1)
y_train = data['attack_class']
y_test = test_data['attack_class']
print(X_train.shape)

from sklearn.ensemble import RandomForestClassifier
rnd_clf = RandomForestClassifier(n_estimators=300, random_state=42)
rnd_clf.fit(X_train, y_train)
y_pred_rf = rnd_clf.predict(X_test)
score_rf=rnd_clf.score(X_test, y_test)
cm_rf=metrics.confusion_matrix(y_test,y_pred_rf)
print("Accuracy of Random Forest")
print(score_rf)
print("Confusion Matrix of Random Forest")
print(cm_rf)

file_path_test1 = './New_Data/new_test+_attack-mul.csv'
test_df1 = pd.read_csv(file_path_test1)

test_data1 = test_df1.copy()

X_test1 = test_data1.drop('attack_class', axis=1)
y_test1 = test_data1['attack_class']

from tensorflow.keras import layers
from tensorflow import keras
class TransformerEncoder(layers.Layer):
    def __init__(self, embed_dim, dense_dim, num_heads, rate=0.1,bias=False,**kwargs):
        super().__init__(**kwargs)
        self.embed_dim = embed_dim
        self.dense_dim = dense_dim
        self.num_heads = num_heads
        self.attention = layers.MultiHeadAttention(num_heads=num_heads, key_dim=embed_dim)
        self.attention = layers.MultiHeadAttention(num_heads=num_heads, key_dim=embed_dim)
        self.dense_proj = keras.Sequential(
            [layers.Dense(dense_dim, activation="relu"),layers.Dense(embed_dim),] )
        self.layernorm_1 = layers.LayerNormalization()
        self.layernorm_2 = layers.LayerNormalization()
        self.dropout1 = layers.Dropout(rate)
        self.dropout2 = layers.Dropout(rate)

    def call(self, inputs, mask=None):
        if mask is not None:
            mask = mask[:, tf.newaxis, :]
        attention_output = self.attention(inputs, inputs, attention_mask=mask)
        proj_input = self.layernorm_1(inputs + attention_output)
        proj_output = self.dense_proj(proj_input)
        return self.layernorm_2(proj_input + proj_output)

    def get_config(self):
        config = super().get_config()
        config.update({
            "embed_dim": self.embed_dim,
            "num_heads": self.num_heads,
            "dense_dim": self.dense_dim, })
        return config

class timecallback(tf.keras.callbacks.Callback):
    def __init__(self):
        self.times = []
        self.epochs = []
        # use this value as reference to calculate cummulative time taken
        self.timetaken = tf.timestamp()
    def on_epoch_end(self,epoch,logs = {}):
        # self.times.append(tf.timestamp() - self.timetaken)
        t=tf.timestamp() - self.timetaken
        self.times.append(t)
        print('cost time: ',t.numpy())

        self.epochs.append(epoch)

model = load_model('./Weights/BiGRU+Trans_test+_mul.h5',custom_objects={'TransformerEncoder':TransformerEncoder})

X_test1 = X_test1.to_numpy()

y_test1 = y_test1.to_numpy()
y_eval = y_test1.copy()

pred = model.predict(X_test1)
class_x = np.argmax(pred, axis=1)
acc = accuracy_score(y_eval, class_x)
print('acc:', acc)
print(classification_report(y_eval, class_x))

cm_Bi=metrics.confusion_matrix(y_eval,class_x)
print("Confusion Matrix of BiGRU")
print(cm_Bi)

cm_final=np.identity(5)
cm_final=cm_Bi
attack_list=[9711,7458,2421,200,2754]
# attack_list=[2152,4342,2402,200,2754]
for i in range(len(attack_list)):
    cm_final[i][0] = cm_Bi[i][0]+(attack_list[i]-(cm_Bi[i][0]+cm_Bi[i][1]+cm_Bi[i][2]+cm_Bi[i][3]+cm_Bi[i][4]))

print("Final Confusion Matrix")
print(cm_final)

def res(cm):
    total=np.sum(cm)
    #Accuracy
    OA = (cm[0][0] + cm[1][1] + cm[2][2] + cm[3][3] + cm[4][4]) / (total)
    return OA

final_matrix=res(cm_final)
print("Accuracy: ",final_matrix)


